library IEEE; 
use IEEE.STD_LOGIC_1164.ALL; 
use IEEE.NUMERIC_STD.ALL; 
 
entity PlayNote is 
    Port ( clk : in  STD_LOGIC;
	        note : in integer;
			  -- limit : in integer;
           audio : out  STD_LOGIC); 
end PlayNote; 
 
architecture Behavioral of PlayNote is 

signal c : integer range 0 to 24999999 := 0; -- 0,5s bei 50MHz fosc
signal x : std_logic:= '0';  

-- Note Hz     Teiler
--
-- C    261.63 382219.1
-- C#   277.18 360773.6
-- D    293.66 340529.6
-- D#   311.13 321409.0
-- E    329.63 303370.4
-- F    349.23 286344.2
-- F#   369.99 270277.5
-- G    392.00 255102.0
-- G#   415.30 240789.7
-- A    440.00 227272.7
-- A#   466.16 214518.6
-- H    493.88 202478.3
-- C1   523.25 191113.2

type note_type is array(0 to 12)of integer;
signal notes: note_type;

begin 
   -- 12 half tones starting from C0
	notes <= ( 382219, 360773, 340529, 321409, 303370, 286344, 270277, 255102, 240789, 227272, 214518, 202478, 191113 );
	
   process begin  
      wait until rising_edge(clk); -- warten bis zum nchsten Takt 
      if (c<notes(note)/2) then            -- 024999999 = 25000000 Takte = 1/2 Sekunde bei 50MHz 
          c <= c+1;                -- wenn kleiner: weiterzhlen 
      else                         -- wenn Zhlerende erreicht: 
          c <= 0;                  -- Zhler zurcksetzen 
          x <= not x;              -- und Signal x togglen 
      end if; 
   end process; 
   audio <= x;                       -- Signal x an LED ausgeben 
end Behavioral;
